
#include <stdio.h>
#include <string.h>	
#include <avr/io.h>	
#include <avr/eeprom.h>	
#include <avr/interrupt.h>
#include <util/delay.h>

	
#include "mmc.h"
#include "fat16.h"


#define ADC_VREF_TYPE 0x40

 unsigned int read_adc(unsigned char);
 void init_uart(void);
 void init_adc(void);
 int uart_putc(unsigned char);
 void uart_puts (char *);
 void init_timer1(void);
 void messen(unsigned int *);
 uint8_t uart_getc(void);
 void uart_gets( char *, uint8_t);
 void zeit_einstellen(void);
 
File *myfile;

char d,m,y;
char sek, min, h;
char zeit[19];

int t2;
char t[7];

unsigned int mes[4];



// Timer 1 overflow interrupt service routine
ISR(TIMER1_OVF_vect)
{
// Reinitialize Timer 1 value
TCNT1H=0xC2;
TCNT1L=0xF8;
	// Place your code here
	sek++;
	
	if (sek>=60)
	{
		sek=0;
		min++;
	}
	if (min>=60)
	{
		min=0; 
		h++;
	}
	if (h>=24)
	{
		h=0;
		d++;
	}
	if ((d>28) && (m==2))
	{
		d=1;
		m++;
	}
	if ((d>30) && ((m==4)||(m==6)||(m==9)||(m==11)))
	{
		d=1;
		m++;
	}
	if( (d>31) && ((m==1)||(m==3)||(m==5)||(m==7)||(m==8)||(m==12)))
	{
		d=1;
		m++;
	}
	if (m>12){
		m=1;
		y++;
	}
		


	//if(PINC==0)
	//	PORTC=0xFF;
	//else
	//	PORTC=0;


	sprintf(zeit,"%2i.%2i.%2i %2i:%2i:%2i\t",y,m,d,h,min,sek);
	uart_puts("\r");
	uart_puts(zeit);
	

if (sek == 30) //+++++++++++++++++++++++++++++++messinterval+++++++++++++++++++++++++
{
	fputs_(myfile,zeit);
	
	//uart_puts("hallo");

// time end, messen anfang
	
	messen(mes);	
				
	for (char i=0;i<4;i++)
	{
		sprintf(t,"%i%c",mes[i],9);
		uart_puts(t);

		fputs_(myfile,t);
	}

//temperatur

	mes[0]=read_adc(5);
	mes[0]*=7;
	mes[0]/=20;
	mes[0]*=139;
	mes[0]/=5;
	t2=(-mes[0]);
	t2+=7532;
	sprintf(t,"%i.%i\n",t2/100,t2%100);
	uart_puts("\t");
	uart_puts(t);

	fputs_(myfile,t);

	if (min==9){
		fclose_(myfile);
		uart_puts("ende");
		
	}
}

}




//Hauptprogramm
int main (void)
{
	

	//Initzialisierungen
	init_uart();
	init_adc();
	init_timer1();

	PORTC=0xFF;
	DDRC=0xFF;
 	

	
	sei();
	

	//Statusmeldung
	uart_puts("System Ready!\r\n");

		
	
	
	uart_puts("\n\n");	
	
		
	while ( mmc_init() !=0) //ist der Rckgabewert ungleich NULL ist ein Fehler aufgetreten
		{
		uart_puts("** Keine MMC/SD Karte gefunden!! **\n");	
		}
	uart_puts("Karte gefunden!!\n");
	


	PORTC &= ~(1 << 7);	

	uart_puts("FAT:");
	
	if(InitFat16())
	{
		uart_puts("FAT OK!!\n\n\r");
		PORTC&=~(1 << 6);
	
		myfile = fopen_("test1.txt",'a');
		
		uart_puts("fopene");		

		if(myfile != NULL)
		{
		
				uart_puts("FILE OK!!");
				PORTC&=~(1 << 5);
																

				fputs_(myfile,"\n\nTime\t100k mV\t10k\t3k3\t100\tTemperatur C");
				fputs_(myfile,"\n");

				
		}
	
	//fflush_(myfile);
	//fclose_(myfile);

	
	

	}	
	else
		uart_puts("no FAT!!\n");
	
	uart_puts("FERTIG!!\r\n");



	zeit_einstellen();

	TIMSK=0x04;
 	

	//Hauptprogramm luft stndig in einer schleife und macht nichts
	while (1)
		{
		}
return (1);
}

//*******************************************************************************
//*******************************************************************************
//*******************************************************************************


unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input|ADC_VREF_TYPE;
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}


//9600 Baud 8N1 @16 MHz
void init_uart()
{
	UCSRA=0x00;
	UCSRB=0x18;
	UCSRC=0x86;
	UBRRH=0x00;
	UBRRL=0x67;
}


//125,000 kHz @16 MHz Referenzspannung: AVcc
void init_adc()
{
	ADMUX=ADC_VREF_TYPE;
	ADCSRA=0x87;
	SFIOR&=0xEF;
}


int uart_putc(unsigned char c)
{
    while (!(UCSRA & (1<<UDRE)))  /* warten bis Senden moeglich */
    {
    }                             
 
    UDR = c;                      /* sende Zeichen */
    return 0;
}


void uart_puts (char *s)
{
    while (*s)
    {   /* so lange *s != '\0' also ungleich dem "String-Endezeichen" */
        uart_putc(*s);
        s++;
    }
}

void init_timer1()
{

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x00;
TCCR1B=0x05;
TCNT1H=0xC2;
TCNT1L=0xF7;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
}
void messen(unsigned int *m)
{
	unsigned int erg;

	PORTC =0;

	for (char i=0;i<4;i++)
	{
		PORTC |= (1 << (7-i) );

		_delay_ms(10);

		erg=read_adc(6);

		erg*=52; //5,2 V > USB

		erg/=16;

		erg*=10;

		erg/=8;

		erg*=10;

		erg/=8;

		m[i]=erg;
	}
}

uint8_t uart_getc(void)
{
    while (!(UCSRA & (1<<RXC)))   // warten bis Zeichen verfuegbar
        ;
    return UDR;                   // Zeichen aus UDR an Aufrufer zurueckgeben
}
 
void uart_gets( char* Buffer, uint8_t MaxLen )
{
  uint8_t NextChar;
  uint8_t StringLen = 0;
 
  NextChar = uart_getc();         // Warte auf und empfange das nchste Zeichen
 
                                  // Sammle solange Zeichen, bis:
                                  // * entweder das String Ende Zeichen kam
                                  // * oder das aufnehmende Array voll ist
  while( NextChar != '\n' && StringLen < MaxLen - 1 ) {
    *Buffer++ = NextChar;
    StringLen++;
    NextChar = uart_getc();
  }
                                 // Noch ein '\0' anhngen um einen Standard
                                  // C-String daraus zu machen
  *Buffer = '\0';
}
//zeit und datum einstellen (uart zuvor configurieren!)
void zeit_einstellen(void)
{
	uart_puts("Datum? yy.mm.dd\n\r");

	uart_gets(zeit,9);

	y=(zeit[0]-'0')*10+(zeit[1]-'0');
	m=(zeit[3]-'0')*10+(zeit[4]-'0');
	d=(zeit[6]-'0')*10+(zeit[7]-'0');
	sprintf(zeit,"%2i:%2i:%2i",y,m,d);

	uart_puts("\n\nZeit? hh:mm:ss\n\r");

	uart_gets(zeit,9);
	
	h=(zeit[0]-'0')*10+(zeit[1]-'0');
	min=(zeit[3]-'0')*10+(zeit[4]-'0');
	sek=(zeit[6]-'0')*10+(zeit[7]-'0');
	sek--;
	sprintf(zeit,"%2i:%2i:%2i",h,min,sek);
	
	uart_puts(zeit);

	uart_puts("\n\n");
}
